import React, { useRef, useEffect } from 'react';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".styles-module_light__-Yxpk {\r\n  color-scheme: light;\r\n  --surfaceColorScheme: var(--surfaceColor, #fff);\r\n  --onSurfaceColorScheme: var(--onSurfaceColor, #141414);\r\n  --closeButtonColorScheme: #3d3d3d;\r\n  --closeButtonHoverColorScheme: #f5f5f5;\r\n  --closeButtonActiveColorScheme: #ebebeb;\r\n  --confirmButtonColorScheme: var(--surfaceColor, #fff);\r\n  --confirmButtonBgColorScheme: var(--onSurfaceColor, #141414);\r\n  --confirmButtonHoverBgColorScheme: #3a3a3a;\r\n  --confirmButtonActiveBgColorScheme: var(--onSurfaceColor, #141414);\r\n  --cancelButtonColorScheme: var(--onSurfaceColor, #141414);\r\n  --cancelButtonBgColorScheme: #f5f5f5;\r\n  --cancelButtonHoverBgColorScheme: #ebebeb;\r\n  --cancelButtonActiveBgColorScheme: #e0e0e0;\r\n}\r\n\r\n.styles-module_light__-Yxpk::backdrop {\r\n  --overlayScheme: var(--dialogBackdropLight, rgba(0,0,0,.32));\r\n}\r\n\r\n.styles-module_dark__iZs3I {\r\n  color-scheme: dark;\r\n  --surfaceColorScheme: var(--surfaceColor, #292929);\r\n  --onSurfaceColorScheme: var(--onSurfaceColor, #e0e0e0);\r\n  --closeButtonColorScheme: #d6d6d6;\r\n  --closeButtonHoverColorScheme: #3a3a3a;\r\n  --closeButtonActiveColorScheme: #141414;\r\n  --confirmButtonColorScheme: #141414;\r\n  --confirmButtonBgColorScheme: #f5f5f5;\r\n  --confirmButtonHoverBgColorScheme: #ebebeb;\r\n  --confirmButtonActiveBgColorScheme: var(--onSurfaceColor, #e0e0e0);\r\n  --cancelButtonColorScheme: var(--onSurfaceColor, #e0e0e0);\r\n  --cancelButtonBgColorScheme: #1f1f1f;\r\n  --cancelButtonHoverBgColorScheme: #3a3a3a;\r\n  --cancelButtonActiveBgColorScheme: #141414;\r\n}\r\n\r\n.styles-module_dark__iZs3I::backdrop {\r\n  --overlayScheme: var(--dialogBackdropDark, rgba(0,0,0,.48));\r\n}\r\n\r\n.styles-module_dialog__qMeos,\r\n.styles-module_dialog__qMeos *,\r\n.styles-module_dialog__qMeos::before,\r\n.styles-module_dialog__qMeos::after,\r\n.styles-module_dialog__qMeos ::before,\r\n.styles-module_dialog__qMeos ::after {\r\n  box-sizing: border-box;\r\n}\r\n\r\n.styles-module_dialog__qMeos {\r\n  min-width: var(--minWidth, 320px);\r\n  width: var(--width, 380px);\r\n  max-width: var(--maxWidth, 95dvw);\r\n  padding: 0;\r\n  font-family: var(--fontFamily, -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Ubuntu, 'Helvetica Neue', sans-serif);\r\n  color: var(--onSurfaceColorScheme);\r\n  background-color: var(--surfaceColorScheme);\r\n  border: var(--border);\r\n  border-radius: var(--borderRadius, 8px);\r\n  outline: var(--outline);\r\n  box-shadow: var(--boxShadow);\r\n}\r\n\r\n.styles-module_dialog__qMeos::backdrop {\r\n  background-color: var(--overlayScheme);\r\n}\r\n\r\n.styles-module_inner__I39Du {\r\n  position: relative;\r\n  display: flex;\r\n  flex-direction: column;\r\n  min-height: var(--minHeight);\r\n  height: var(--height, auto);\r\n  max-height: var(--maxHeight);\r\n  padding: var(--padding, 1rem);\r\n}\r\n\r\n.styles-module_header__2msgj {\r\n  display: flex;\r\n  gap: 1rem;\r\n  align-items: flex-start;\r\n}\r\n\r\n.styles-module_title__Vedzp {\r\n  margin: 0;\r\n  padding-block-end: 1rem;\r\n  text-wrap: balance;\r\n  font-size: var(--titleFontSize, 1.125rem);\r\n  font-weight: var(--titleFontWeight, 700);\r\n  font-style: var(--titleFontStyle, normal);\r\n  line-height: var(--titleLineHeight, 1.33);\r\n}\r\n\r\n.styles-module_closeButton__hbqbL {\r\n  position: relative;\r\n  top: -0.5rem;\r\n  right: -0.5rem;\r\n  display: flex;\r\n  justify-content: center;\r\n  align-items: center;\r\n  margin-inline-start: auto;\r\n  padding: .5rem;\r\n  color: var(--closeButtonColorScheme);\r\n  background-color: transparent;\r\n  border: none;\r\n  border-radius: var(--closeButtonBorderRadius, 4px);\r\n  cursor: pointer;\r\n  transition:\r\n    color .15s, background-color .15s,\r\n    border-color .15s, outline-color .15s, box-shadow .15s;\r\n}\r\n\r\n.styles-module_closeButton__hbqbL:hover,\r\n.styles-module_closeButton__hbqbL:focus-visible {\r\n  background-color: var(--closeButtonHoverColorScheme);\r\n}\r\n\r\n.styles-module_closeButton__hbqbL:active {\r\n  background-color: var(--closeButtonActiveColorScheme);\r\n}\r\n\r\n.styles-module_body__u1SN8 {\r\n  padding-block-end: 1rem;\r\n}\r\n\r\n.styles-module_dialog__qMeos p {\r\n  margin-block: 0;\r\n  font-weight: var(--paragraphFontWeight, 500);\r\n  line-height: var(--paragraphLineHeight, 1.5);\r\n}\r\n\r\n.styles-module_footer__0lM5Y {\r\n  display: flex;\r\n  flex-direction: var(--footerDirection, row);\r\n  justify-content: var(--buttonsAlign, flex-end);\r\n  gap: .5rem;\r\n  margin-block-start: auto;\r\n  padding-block-start: 1rem;\r\n}\r\n\r\n.styles-module_footer__0lM5Y button {\r\n  display: flex;\r\n  justify-content: center;\r\n  align-items: center;\r\n  padding: .5rem 1rem;\r\n  font-family: inherit;\r\n  font-size: .875rem;\r\n  font-weight: 500;\r\n  line-height: var(--actionButtonLineHeight, 1.71);\r\n  border: none;\r\n  border-radius: 4px;\r\n  cursor: pointer;\r\n  transition:\r\n    color .15s, background-color .15s,\r\n    border-color .15s, outline-color .15s, box-shadow .15s;\r\n}\r\n\r\n.styles-module_footer__0lM5Y button:disabled {\r\n  pointer-events: none;\r\n  opacity: .32;\r\n}\r\n\r\n.styles-module_footerStretch__Pvoje button {\r\n  flex: 1;\r\n}\r\n\r\n.styles-module_confirmButton__3eAkF {\r\n  color: var(--confirmButtonColorScheme);\r\n  background-color: var(--confirmButtonBgColorScheme);\r\n}\r\n\r\n.styles-module_confirmButton__3eAkF:hover,\r\n.styles-module_confirmButton__3eAkF:focus-visible {\r\n  background-color: var(--confirmButtonHoverBgColorScheme);\r\n}\r\n\r\n.styles-module_confirmButton__3eAkF:active {\r\n  background-color: var(--confirmButtonActiveBgColorScheme);\r\n}\r\n\r\n.styles-module_cancelButton__uWYiO {\r\n  color: var(--cancelButtonColorScheme);\r\n  background-color: var(--cancelButtonBgColorScheme);\r\n}\r\n\r\n.styles-module_cancelButton__uWYiO:hover,\r\n.styles-module_cancelButton__uWYiO:focus-visible {\r\n  background-color: var(--cancelButtonHoverBgColorScheme);\r\n}\r\n\r\n.styles-module_cancelButton__uWYiO:active {\r\n  background-color: var(--cancelButtonActiveBgColorScheme);\r\n}\r\n";
var styles = {"light":"styles-module_light__-Yxpk","dark":"styles-module_dark__iZs3I","dialog":"styles-module_dialog__qMeos","inner":"styles-module_inner__I39Du","header":"styles-module_header__2msgj","title":"styles-module_title__Vedzp","closeButton":"styles-module_closeButton__hbqbL","body":"styles-module_body__u1SN8","footer":"styles-module_footer__0lM5Y","footerStretch":"styles-module_footerStretch__Pvoje","confirmButton":"styles-module_confirmButton__3eAkF","cancelButton":"styles-module_cancelButton__uWYiO"};
styleInject(css_248z);

const getFooterButtonsAlign = (align) => {
    if (!align)
        return {};
    if (align === 'center')
        return { '--buttonsAlign': align };
    if (align === 'start' || align === 'end')
        return { '--buttonsAlign': `flex-${align}` };
    if (align === 'between' || align === 'around' || align === 'evenly')
        return { '--buttonsAlign': `space-${align}` };
    return {};
};
const getButtonStyles = (styles, order) => {
    let buttonStyles = {};
    if (styles)
        buttonStyles = Object.assign({}, styles);
    if (order)
        buttonStyles = Object.assign(Object.assign({}, styles), { order });
    return buttonStyles;
};
const convertToVanillaCSS = (styles) => {
    let values = '';
    if (!styles || Object.keys(styles).length === 0)
        return values;
    for (const [key, value] of Object.entries(styles)) {
        values = values.concat(`${key}: ${value} !important; `);
    }
    return values.trim();
};
const mergeVanillaCSS = (styles, classNames) => {
    return styles.map(style => {
        if (style.value.length > 0) {
            return style.type === 'hover' ? (`
.${classNames[style.className]}${style.className === 'footer' ? ' button' : ''}:hover,
.${classNames[style.className]}${style.className === 'footer' ? ' button' : ''}:focus-visible {
  ${style.value}
}`) : (`
.${classNames[style.className]}${style.className === 'footer' ? ' button' : ''}:active {
  ${style.value}
}`);
        }
        return '';
    }).join('');
};
const getStyleElementCSS = (classNames, userStyles) => {
    const buttonsHoverValues = convertToVanillaCSS(userStyles.buttonsHoverStyles);
    const buttonsActiveValues = convertToVanillaCSS(userStyles.buttonsActiveStyles);
    const confirmButtonHoverValues = convertToVanillaCSS(userStyles.confirmButtonHoverStyles);
    const confirmButtonActiveValues = convertToVanillaCSS(userStyles.confirmButtonActiveStyles);
    const cancelButtonHoverValues = convertToVanillaCSS(userStyles.cancelButtonHoverStyles);
    const cancelButtonActiveValues = convertToVanillaCSS(userStyles.cancelButtonActiveStyles);
    const closeButtonHoverValues = convertToVanillaCSS(userStyles.closeButtonHoverStyles);
    const closeButtonActiveValues = convertToVanillaCSS(userStyles.closeButtonActiveStyles);
    const styles = [
        { type: 'hover', className: 'footer', value: buttonsHoverValues },
        { type: 'active', className: 'footer', value: buttonsActiveValues },
        { type: 'hover', className: 'confirmButton', value: confirmButtonHoverValues },
        { type: 'active', className: 'confirmButton', value: confirmButtonActiveValues },
        { type: 'hover', className: 'cancelButton', value: cancelButtonHoverValues },
        { type: 'active', className: 'cancelButton', value: cancelButtonActiveValues },
        { type: 'hover', className: 'closeButton', value: closeButtonHoverValues },
        { type: 'active', className: 'closeButton', value: closeButtonActiveValues },
    ];
    return mergeVanillaCSS(styles, classNames);
};
const Dialog = ({ isDialogOpen, setIsDialogOpen, escKeyAction, closeButtonAction, confirmButtonAction, cancelButtonAction, dialogCloseAction, children, theme = 'light', dialogClassNames, innerClassNames, headerClassNames, titleClassNames, closeButtonClassNames, bodyClassNames, footerClassNames, confirmButtonClassNames, cancelButtonClassNames, title, showCloseButton = true, confirmButtonText, cancelButtonText, isConfirmButtonDisabled = false, isCancelButtonDisabled = false, minWidth, width, maxWidth, minHeight, height, maxHeight, padding, fontFamily, surfaceColor, onSurfaceColor, border, borderRadius, outline, boxShadow, titleFontSize, titleFontWeight, titleFontStyle, titleLineHeight, dialogStyles, headerStyles, bodyStyles, footerStyles, footerDirection, buttonsAlign, buttonsStyles, buttonsHoverStyles, buttonsActiveStyles, confirmButtonStyles, confirmButtonHoverStyles, confirmButtonActiveStyles, confirmButtonAriaLabel, confirmButtonOrder, cancelButtonStyles, cancelButtonHoverStyles, cancelButtonActiveStyles, cancelButtonAriaLabel, cancelButtonOrder, closeButtonStyles, closeButtonHoverStyles, closeButtonActiveStyles, closeButtonIcon, closeButtonIconStyles, closeButtonAriaLabel = 'close dialog', additionalFooterButtons, }) => {
    const dialogRef = useRef(null);
    useEffect(() => {
        var _a, _b;
        if (dialogRef && isDialogOpen)
            (_a = dialogRef.current) === null || _a === void 0 ? void 0 : _a.showModal();
        if (dialogRef && !isDialogOpen)
            (_b = dialogRef.current) === null || _b === void 0 ? void 0 : _b.close();
    }, [isDialogOpen, dialogRef]);
    const dialogUserStyles = Object.assign(Object.assign({}, dialogStyles), { '--minWidth': minWidth, '--width': width, '--maxWidth': maxWidth, '--fontFamily': fontFamily, '--surfaceColor': surfaceColor, '--onSurfaceColor': onSurfaceColor, '--border': border, '--borderRadius': borderRadius, '--outline': outline, '--boxShadow': boxShadow });
    const innerUserStyles = {
        '--minHeight': minHeight,
        '--height': height,
        '--maxHeight': maxHeight,
        '--padding': padding,
    };
    const titleUserStyles = {
        '--titleFontSize': titleFontSize,
        '--titleFontWeight': titleFontWeight,
        '--titleFontStyle': titleFontStyle,
        '--titleLineHeight': titleLineHeight,
    };
    const footerButtonsAlign = getFooterButtonsAlign(buttonsAlign);
    const confirmActionButtonStyles = getButtonStyles(confirmButtonStyles, confirmButtonOrder);
    const cancelActionButtonStyles = getButtonStyles(cancelButtonStyles, cancelButtonOrder);
    const styleElementCss = getStyleElementCSS(styles, {
        buttonsHoverStyles,
        buttonsActiveStyles,
        confirmButtonHoverStyles,
        confirmButtonActiveStyles,
        cancelButtonHoverStyles,
        cancelButtonActiveStyles,
        closeButtonHoverStyles,
        closeButtonActiveStyles,
    });
    const footerUserStyles = Object.assign(Object.assign(Object.assign({}, footerButtonsAlign), footerStyles), { '--footerDirection': footerDirection });
    const confirmButtonUserStyles = Object.assign(Object.assign({}, buttonsStyles), confirmActionButtonStyles);
    const cancelButtonUserStyles = Object.assign(Object.assign({}, buttonsStyles), cancelActionButtonStyles);
    const handleCloseEvent = () => {
        if (dialogCloseAction)
            dialogCloseAction();
    };
    const handleEscape = () => {
        if (escKeyAction)
            escKeyAction();
        setIsDialogOpen(false);
    };
    const handleClose = () => {
        if (closeButtonAction)
            closeButtonAction();
        setIsDialogOpen(false);
    };
    const handleConfirm = () => {
        if (confirmButtonAction)
            confirmButtonAction();
        setIsDialogOpen(false);
    };
    const handleCancel = () => {
        if (cancelButtonAction)
            cancelButtonAction();
        setIsDialogOpen(false);
    };
    return (React.createElement("dialog", { ref: dialogRef, style: dialogUserStyles, onCancel: handleEscape, onClose: handleCloseEvent, className: `${styles[theme]} ${styles.dialog}${dialogClassNames
            ? ` ${dialogClassNames}` : ''}` },
        styleElementCss && (React.createElement("style", null, styleElementCss)),
        React.createElement("div", { style: innerUserStyles, className: `${styles.inner}${innerClassNames
                ? ` ${innerClassNames}` : ''}` },
            (title || showCloseButton) && (React.createElement("header", { style: headerStyles, className: `${styles.header}${headerClassNames
                    ? ` ${headerClassNames}` : ''}` },
                title && (React.createElement("h1", { style: titleUserStyles, className: `${styles.title}${titleClassNames
                        ? ` ${titleClassNames}` : ''}` }, title)),
                showCloseButton && (React.createElement("button", { type: "button", style: closeButtonStyles, onClick: handleClose, "aria-label": closeButtonAriaLabel, className: `${styles.closeButton}${closeButtonClassNames
                        ? ` ${closeButtonClassNames}` : ''}` }, closeButtonIcon ? (closeButtonIcon) : (React.createElement("svg", { width: "16", height: "16", viewBox: "0 0 16 16", fill: "currentColor", "aria-hidden": "true", style: closeButtonIconStyles },
                    React.createElement("path", { d: "M7.147 7.91 2.854 3.463l.959-.926 4.277 4.43 4.105-4.105.943.943-4.122 4.121 4.13 4.278-.959.926-4.113-4.26-4.27 4.268-.942-.943L7.147 7.91Z" }))))))),
            children && (React.createElement("div", { style: bodyStyles, className: `${styles.body}${bodyClassNames
                    ? ` ${bodyClassNames}` : ''}` }, children)),
            (confirmButtonText || cancelButtonText || additionalFooterButtons) && (React.createElement("footer", { style: footerUserStyles, className: buttonsAlign === 'stretch'
                    ? `${styles.footer} ${styles.footerStretch}${footerClassNames
                        ? ` ${footerClassNames}` : ''}`
                    : `${styles.footer}${footerClassNames
                        ? ` ${footerClassNames}` : ''}` },
                additionalFooterButtons && additionalFooterButtons,
                cancelButtonText && (React.createElement("button", { type: "button", style: cancelButtonUserStyles, onClick: handleCancel, disabled: isCancelButtonDisabled, "aria-label": cancelButtonAriaLabel, className: `${styles.cancelButton}${cancelButtonClassNames
                        ? ` ${cancelButtonClassNames}` : ''}` }, cancelButtonText)),
                confirmButtonText && (React.createElement("button", { type: "button", style: confirmButtonUserStyles, onClick: handleConfirm, disabled: isConfirmButtonDisabled, "aria-label": confirmButtonAriaLabel, className: `${styles.confirmButton}${confirmButtonClassNames
                        ? ` ${confirmButtonClassNames}` : ''}` }, confirmButtonText)))))));
};

export { Dialog };
//# sourceMappingURL=index.es.js.map
